#include <stdio.h>
#include <allegro.h>

#include "map.h"        //Map routines
#include "sound.h"      //Sound processing routines
#include "prjxmain.h"   //Main hub of the game
#include "startup.h"    //Game startup routines
#include "central.h"    //Central game routines
#include "shutdown.h"   //Game shutdown routines
#include "keyboard.h"   //Keyboard handling routines
#include "graphics.h"   //Graphics processing routines
#include "menu.h"       //Menu routines

void TIMER_PlayerLoc()
{
   switch(GAME_STAT)
   {
      case MAINMAP:
         textprintf(screen,font,1,180,COLOR_RED,"Player Location: %ix - %iy",(PL_player.x+8),(PL_player.y+5));

         textprintf(screen,font,275,1,COLOR_YELLOW,"  HP");
         rectfill(screen,275,10,319,20,COLOR_BLACK);
         textprintf(screen,font,275,10,COLOR_RED,"%i",PL_player.hp);

         textprintf(screen,font,275,31,COLOR_YELLOW,"  MP");
         rectfill(screen,275,40,319,50,COLOR_BLACK);
         textprintf(screen,font,275,40,COLOR_RED,"%i",PL_player.mp);

         textprintf(screen,font,275,61,COLOR_YELLOW," AMMO");
         rectfill(screen,275,70,319,80,COLOR_BLACK);
         textprintf(screen,font,275,70,COLOR_RED,"%i",PL_player.ammo);
         break;
   }

   if(PL_player.hp<=0 && GAME_STAT==MAINMAP)
   {
      TIMER_CharMoveVar=-2;
   }

} END_OF_FUNCTION(TIMER_PlayerLoc);

void TIMER_CharMove()
{
   switch(GAME_STAT)
   {
      case MAINMAP:
         TIMER_CharMoveVar=1;
         break;
   }
} END_OF_FUNCTION(TIMER_CharMove);

int main()
{
   int GooBeR = 0;  // Dummy variable to keep the program looping

   SndVol = 51; // A Range from 0 to 255 in steps of 5 (or 3 for slidebar)
   MidiVol = 1; // 0 or 1 ... Off or On

   do_config();            // Do the dos sound configuration
   do_startup();           // Startup allegro graphics and sound
   do_logo();              // Present the logo screen
   show_mainmenu(1);       // Show the main menu
   do_mainmenu(KeyWay);    // Enter the Main Menu handling section

   install_int_ex(TIMER_CharMove,BPM_TO_TIMER(80));
   install_int_ex(TIMER_PlayerLoc,BPS_TO_TIMER(20));
   LOCK_FUNCTION(TIMER_CharMove);
   LOCK_FUNCTION(TIMER_PlayerLoc);
   LOCK_VARIABLE(PL_player);
   LOCK_VARIABLE(Map);
   LOCK_VARIABLE(GAME_STAT);
   LOCK_VARIABLE(SndVol);
   LOCK_VARIABLE(TIMER_CharMoveVar);

   do
   {
      switch(GAME_STAT)       // ** Find out where you are in the game
      {
         case MAINMENU:       // *!* In the main menu
            KBD_MainMenu();         // -*- Go to the keyboard handling routines for the main menu
            break;
         case SETUPMENU:      // *!* In the setup menu
            KBD_SetupMenu();        // -*- Go to the keyboard handling routines for the setup menu
            break;
         case MAINMAP:     // *!* In the main map
            switch(TIMER_CharMoveVar)
            {
               case -2:          // player died
                  fade_out(1);
                  show_mainmenu(1);       // Show the main menu
                  do_mainmenu(KeyWay);    // Enter the Main Menu handling section
                  break;
               case -1:
                  TIMER_CharMoveVar=0;
                  StartNewGame();
                  break;
               case 1:     // normal mainmap movement
                  MAP_MoveEnemies();  //move all enemies on the screen
                  MAP_CheckLocation(); //Check where you are to see if there's anything important there (enemy, etc.)
                  MAP_DisplayMap();
                  MAP_ShowPlayer(PL_player.direction);
                  TIMER_CharMoveVar=0;
                  break;
            }
            KBD_MainMap();          // -*- Go to the keyboard handling routines for the main map
            break;
      }
   } while(GooBeR==0);
}



